Skip to main content

Getting started with Angular and Canvas via Konva

How to use canvas with Angular?

ng2-konva is a JavaScript library for drawing complex canvas graphics using Angular. It provides declarative and reactive bindings to the Konva Framework.

Github Repo

It is an attempt to make Angular work with the HTML5 canvas library. The goal is to have a similar declarative markup as normal Angular and also a similar data-flow model.

All ng2-konva components correspond to Konva components of the same name with the prefix 'ko-'. All the parameters available for Konva objects can be added as config in the property binding for corresponding ng2-konva components.

Core shapes are: ko-rect, ko-circle, ko-ellipse, ko-line, ko-image, ko-text, ko-text-path, ko-star, ko-label, ko-path, ko-regular-polygon. Also you can create custom shapes.

To get more info about Konva you can read Konva Overview.

For Angular 21 apps, plain static configs work well for simple demos. If you update a config from async callbacks such as image loading, prefer Angular signals.

Quick Start

Angular version 20+ is required.

1. Install via npm

npm install ng2-konva konva --save

2. Import and use ng2-konva

import {
CoreShapeComponent,
StageComponent,
} from 'ng2-konva';

@Component({
// ... other config
standalone: true,
template: `
<ko-stage [config]="configStage">
<ko-layer>
<ko-circle [config]="configCircle"></ko-circle>
</ko-layer>
</ko-stage>
`,
imports: [StageComponent, CoreShapeComponent],
})
export default class App {
public configStage: StageConfig = {
width: window.innerWidth,
height: window.innerHeight,
};
public configCircle: CircleConfig = {
x: 100,
y: 100,
radius: 50,
fill: 'red',
};
}

3. Use in your components

Instructions: Try to drag the stars. They will scale up while being dragged and return to normal size when released.

import { Component, OnInit, viewChild } from '@angular/core';
import Konva from 'konva';
import { StarConfig } from 'konva/lib/shapes/Star';
import { StageConfig } from 'konva/lib/Stage';
import {
  CoreShapeComponent,
  NgKonvaEventObject,
  StageComponent,
} from 'ng2-konva';

type ExtStartConfig = StarConfig & { startScale: number };

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <ko-stage [config]="configStage">
      <ko-layer>
        @for (config of starConfigs; track trackConfig($index, config)) {
          <ko-star
            (dragstart)="handleDragstart($event.event)"
            (dragend)="handleDragend($event.event)"
            [config]="config"
          />
        }
      </ko-layer>
    </ko-stage>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class StarExampleComponent implements OnInit {
  public width = 800;
  public height = 800;
  public starConfigs: ExtStartConfig[] = [];

  public configStage: Partial<StageConfig> = {
    width: this.width,
    height: this.height,
  };

  public handleDragstart(
    event: NgKonvaEventObject<MouseEvent>,
  ): void {
    const shape = event.target;

    this.starConfigs = this.starConfigs.map((conf) => {
      if ( conf.name !== shape.name()) {
        return conf;
      }
      return {
        ...conf,
        shadowOffsetX: 15,
        shadowOffsetY: 15,
        scaleX: conf.startScale * 1.2,
        scaleY: conf.startScale * 1.2,
      };
    });
    this.starConfigs = [
      ...this.starConfigs.filter((conf) => conf.name !== shape.name()),
      this.starConfigs.find((conf) => conf.name === shape.name())!,
    ];
  }

  public handleDragend(
    event: NgKonvaEventObject<MouseEvent>,
  ): void {
    const shape = event.target;
    this.starConfigs = this.starConfigs.map((conf) => {
      if (conf.name !== shape.name()) {
        return conf;
      }
      return {
        ...conf,
        x: shape.x(),
        y: shape.y(),
        scaleX: conf.startScale,
        scaleY: conf.startScale,
      };
    });
  }

  trackConfig(index: number, config: ExtStartConfig): string | undefined {
    return config.name;
  }

  public ngOnInit(): void {
    for (let n = 0; n < 100; n++) {
      const scale = Math.random();
      this.starConfigs.push({
        x: Math.random() * this.width,
        y: Math.random() * this.height,
        rotation: Math.random() * 180,
        numPoints: 5,
        innerRadius: 30,
        outerRadius: 50,
        fill: '#89b717',
        opacity: 0.8,
        draggable: true,
        scaleX: scale,
        scaleY: scale,
        shadowColor: 'black',
        shadowBlur: 10,
        shadowOffsetX: 5,
        shadowOffsetY: 5,
        shadowOpacity: 0.6,
        startScale: scale,
        name: n.toString(),
      });
    }
  }
}

For full list of properties and methods, see the Konva API Reference.

Skip to main content

Getting started with Vue and Canvas via Konva

How to use canvas with Vue?

VueKonva Logo

Vue Konva is a JavaScript library for drawing complex canvas graphics using Vue.

It provides declarative and reactive bindings to the Konva Framework.

All vue-konva components correspond to Konva components of the same name with the prefix 'v-'. All the parameters available for Konva objects can be added as config in the prop for corresponding vue-konva components.

Core shapes are: v-rect, v-circle, v-ellipse, v-line, v-image, v-text, v-text-path, v-star, v-label, v-path, v-regular-polygon. Also you can create custom shapes.

To get more info about Konva you can read Konva Overview.

Quick Start

Vue.js version 3 is required.

1. Install via npm

npm install vue-konva konva --save

2. Choose your import style

You can use vue-konva in two ways:

Register all components globally using the plugin:

import { createApp } from 'vue';
import App from './App.vue';
import VueKonva from 'vue-konva';

const app = createApp(App);
app.use(VueKonva);
app.mount('#app');

After global registration, all components are available with v- prefix: v-stage, v-layer, v-rect, v-circle, etc.

Option B: On-Demand Import

Import only the components you need:

<template>
<v-stage :config="stageSize">
<v-layer>
<v-circle :config="circleConfig" />
</v-layer>
</v-stage>
</template>

<script setup>
import { Stage as VStage, Layer as VLayer, Circle as VCircle } from 'vue-konva';

const stageSize = {
width: 200,
height: 200
};

const circleConfig = {
x: 100,
y: 100,
radius: 70,
fill: 'red',
stroke: 'black',
strokeWidth: 4
};
</script>

3. Example: Draggable Stars

Instructions: Try to drag the stars. They will scale up while being dragged and return to normal size when released.

<template>
  <v-stage
    ref="stage"
    :config="stageSize"
    @dragstart="handleDragstart"
    @dragend="handleDragend"
  >
    <v-layer ref="layer">
      <v-star
        v-for="item in list"
        :key="item.id"
        :config="{
          x: item.x,
          y: item.y,
          rotation: item.rotation,
          id: item.id,
          numPoints: 5,
          innerRadius: 30,
          outerRadius: 50,
          fill: '#89b717',
          opacity: 0.8,
          draggable: true,
          scaleX: dragItemId === item.id ? item.scale * 1.2 : item.scale,
          scaleY: dragItemId === item.id ? item.scale * 1.2 : item.scale,
          shadowColor: 'black',
          shadowBlur: 10,
          shadowOffsetX: dragItemId === item.id ? 15 : 5,
          shadowOffsetY: dragItemId === item.id ? 15 : 5,
          shadowOpacity: 0.6
        }"
      />
    </v-layer>
  </v-stage>
</template>

<script setup>
import { ref, onMounted } from 'vue';

const stageSize = {
  width: window.innerWidth,
  height: window.innerHeight
};

const list = ref([]);
const dragItemId = ref(null);

const handleDragstart = (e) => {
  // save drag element:
  dragItemId.value = e.target.id();
  // move current element to the top:
  const item = list.value.find(i => i.id === dragItemId.value);
  const index = list.value.indexOf(item);
  list.value.splice(index, 1);
  list.value.push(item);
};

const handleDragend = () => {
  dragItemId.value = null;
};

onMounted(() => {
  for (let n = 0; n < 30; n++) {
    list.value.push({
      id: Math.round(Math.random() * 10000).toString(),
      x: Math.random() * stageSize.width,
      y: Math.random() * stageSize.height,
      rotation: Math.random() * 180,
      scale: Math.random()
    });
  }
});
</script>

Or use a CDN

<html>
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
<meta http-equiv="x-ua-compatible" content="ie=edge" />
</head>
<body>
<div id="app">
<v-stage ref="stage" :config="configKonva">
<v-layer ref="layer">
<v-circle :config="configCircle" />
</v-layer>
</v-stage>
</div>
<!--1. Link Vue Javascript & Konva-->
<script src="https://unpkg.com/vue@3/dist/vue.global.js"></script>
<script src="https://unpkg.com/konva@9/konva.min.js"></script>
<!--2. Link VueKonva Javascript (Plugin automatically installed)-->
<script src="https://unpkg.com/vue-konva@3/dist/vue-konva.umd.js"></script>
<script>
// 3. Create the Vue instance
const { createApp, ref } = Vue;
const VueKonva = window['vue-konva'].default;

const app = createApp({
setup() {
const configKonva = {
width: 200,
height: 200
};

const configCircle = {
x: 100,
y: 100,
radius: 70,
fill: 'red',
stroke: 'black',
strokeWidth: 4
};

return {
configKonva,
configCircle
};
}
});

app.use(VueKonva);
app.mount('#app');
</script>
</body>
</html>

Skip to main content

React Canvas Library — Getting Started with react-konva

React Konva Logo — React Canvas Library

react-konva is a React canvas library for drawing complex 2D graphics. It provides declarative bindings to the Konva Framework. You can use familiar React components and data flow.

GitHub repository

With react-konva you write canvas graphics the same way you write React DOM — with JSX components, props, state, and hooks. Every Konva shape (Rect, Circle, Line, Text, Image, Star, and more) is available as a React component with full event support.

Note: react-konva works in the browser only and is not supported in React Native. React Native has no DOM and no <canvas> element, so there is nothing for Konva to draw into. If you already have a Konva editor on the web, running it inside a WebView is a practical option. For a new native app, use React Native Skia.

You can find dozens of interactive demos at konvajs.org. Browser scene-graph features are available through React components or Konva node refs. Use Konva directly for Node.js rendering. Think of it as: Konva is to react-konva what the DOM is to React.

Installation

The react-konva major version must match the React major version. For React 19, install the current packages:

npm install react-konva konva

For React 18, install react-konva 18:

npm install react-konva@18 konva

Here's a basic example showing how to create a simple canvas with some shapes:

import React, { useState } from 'react';
import { Stage, Layer, Rect, Circle, Text } from 'react-konva';

const App = () => {
const [rectPosition, setRectPosition] = useState({ x: 20, y: 50 });
const [circlePosition, setCirclePosition] = useState({ x: 200, y: 100 });

return (
<Stage width={window.innerWidth} height={window.innerHeight}>
<Layer>
<Text text="Try to drag shapes" fontSize={15} />
<Rect
x={rectPosition.x}
y={rectPosition.y}
width={100}
height={100}
fill="red"
shadowBlur={10}
draggable
onDragEnd={(e) => setRectPosition(e.target.position())}
/>
<Circle
x={circlePosition.x}
y={circlePosition.y}
radius={50}
fill="green"
draggable
onDragEnd={(e) => setCirclePosition(e.target.position())}
/>
</Layer>
</Stage>
);
};

export default App;

What people build with react-konva

Most production canvas applications fall into a few shapes. Each demo below is runnable, and several also show the vanilla and Vue versions side by side:

If you need the whole editor rather than the primitives, Polotno is a commercial design editor SDK built on Konva by the Konva maintainers. Its UI is React, so it drops into a React app as components: npm install polotno.